#include "DSSV.h"
#include "SinhVien.h"
#include<iostream>
#include<conio.h>

using namespace std;

DSSV::DSSV()
{
	_soLuong = 0;
	_dssv.resize(0);
}

DSSV::~DSSV()
{
	_dssv.clear();
}

void DSSV::NhapDSSV()
{
	cout << "Nhap so sinh vien trong danh sach: ";
	cin >> this->_soLuong;

	for (int i = 0; i < _soLuong; i++)
	{
		SinhVien tmp;
		cout << "~~\t~~\t~~\t~~";
		cout << "\n\t>Sinh vien " << i + 1 << ": ";
		tmp.NhapSV();
		_dssv.push_back(tmp);
	}
}

void DSSV::XuatDSSV()
{
	cout << "\n\tDanh sach sinh vien: ";
	for (int i = 0; i < _soLuong; i++)
	{
		cout << "\n\tSinh vien " << i + 1 << ": \n";
		_dssv[i].XuatSV();
	}
}

void DSSV::SapXep()
{
	for(int i=0;i<_soLuong-1;i++)
		for (int j = i + 1; j < _soLuong; j++)
		{
			if (_dssv[j].layDTB() > _dssv[i].layDTB())
			{
				SinhVien tmp = _dssv[i];
				_dssv[i] = _dssv[j];
				_dssv[j] = tmp;
			}
		}
}

vector<DSSV> DSSV::phanloai()
{
	vector<DSSV> DXL(7);

	for (int i = 0; i < _soLuong; i++)
	{
		double DTB = _dssv[i].layDTB();
		if (DTB >= 9.0) {
			DXL[0]._dssv.push_back(_dssv[i]); DXL[0]._soLuong++;
		}
		if (DTB >= 8.0 && DTB <9.0) {
			DXL[1]._dssv.push_back(_dssv[i]); DXL[1]._soLuong++;
		}
		if (DTB >= 7.0 && DTB < 8.0) {
			DXL[2]._dssv.push_back(_dssv[i]); DXL[2]._soLuong++;
		}
		if (DTB >= 6.0 && DTB < 7.0) {
			DXL[3]._dssv.push_back(_dssv[i]); DXL[3]._soLuong++;
		}
		if (DTB >= 5.0 && DTB < 6.0) {
			DXL[4]._dssv.push_back(_dssv[i]); DXL[4]._soLuong++;
		}
		if (DTB >= 3.0 && DTB < 5.0) {
			DXL[5]._dssv.push_back(_dssv[i]); DXL[5]._soLuong++;
		}
		if (DTB <3.0) {
			DXL[6]._dssv.push_back(_dssv[i]); DXL[6]._soLuong++;
		}
	}
	return DXL;
}

void DSSV::InSauSapXep(vector<DSSV> a, string s[7])
{
	for (int i = 0; i < 7; i++)
	{
		if (a[i]._soLuong)
		{
			cout << "~~\t~~\t~~\n";
			cout << "\n\t>> Danh sach sinh vien loai " << s[i] << " la:\n";
			a[i].XuatDSSV();
		}
	}
}

void main()
{
	DSSV a;
	cout << "Xin moi nhap danh sach Sinh Vien: \n";
	a.NhapDSSV();
	a.SapXep();
	cout << "\n>>> Danh sach sinh vien sau khi sap xep: \n";
	a.XuatDSSV();
	string xepLoai[7] = { "Xuat Sac", "Gioi", "Kha", "Trung Binh Kha", "Trung Binh", "Yeu", "Kem" };
	a.InSauSapXep(a.phanloai(), xepLoai);
	_getch();
}
