#include "DuongTron.h"
#include"DuongThang.h"
#include<math.h>
#include<iostream>
#include<conio.h>

#define MIN  0.0000000001

using namespace std;


DuongTron::DuongTron()
{
	_bk = 0;
}


DuongTron::~DuongTron()
{
}

void DuongTron::NhapDuongTron()
{
	cout << "Nhap toa do tam: ";
	_tam.NhapDiem();
	cout << "Nhap ban kinh: ";
	cin >> _bk;
}

int DuongTron::XetViTri(Diem p)
{
	double KhoangCach = _tam.tinhKhoangCach(p);
	if (KhoangCach > _bk) return 1;
	if (fabs(KhoangCach - _bk) < MIN) return 0;
	else return -1;
}

int DuongTron::XetViTri(DuongThang d)
{
	if (d.timKC(_tam) > _bk) return 1;
	if (fabs(d.timKC(_tam) - _bk) < MIN) return 0;
	if (d.timKC(_tam) < _bk) return -1;
}

Diem DuongTron::timKCmax(Diem *d, int size)
{
	double max = _tam.tinhKhoangCach(d[0]);
	int pos = 0;
	for (int i = 0; i < size;i++)
	{
		if (_tam.tinhKhoangCach(d[i]) > max)
		{
			max = _tam.tinhKhoangCach(d[i]);
			pos = i;
		}
	}
	return d[pos];
}

void main()
{
	DuongTron dt;
	cout << "Moi nhap thong tin duong tron: \n";
	dt.NhapDuongTron();
	int n;
	cout << "Nhap so diem: ";
	cin >> n;
	Diem *d = new Diem[n];
	for (int i = 0; i < n; i++)
	{
		cout << "Nhap diem " << i + 1 << ": ";
		d[i].NhapDiem();
	}
	
	cout << "Khoang cach voi tam lon nhat la diem ";
	dt.timKCmax(d, n).InDiem();
	cout << endl;

	bool tx = false;
	for (int i = 0; i < n - 1; i++)
	{
		if (tx) break;
		for (int j = i + 1; j < n; j++)
		{
			DuongThang d(d[i], d[j]);
			if (dt.XetViTri(d) == 0)
			{
				tx = true;
				break;
			}
		}
	}
	if (tx) cout << "Co duong thang tiep xuc voi duong tron.";
	else cout << "Khong co duong thang nao tiep xuc voi duong tron.";
	_getch();
}
