#include "DSPS.h"
#include<iostream>
#include<conio.h>

using namespace std;


DSPS::DSPS()
{
	_size = 0;
	_dsps.resize(0);
}

DSPS::DSPS(int size)
{
	_size = size;
	_dsps.resize(0);
}

DSPS::~DSPS()
{
	_dsps.clear();
}

void DSPS::NhapDSPS()
{
	cout << "Nhap kich thuoc: ";
	cin >> _size;
	for (int i = 0; i < _size; i++)
	{
		PhanSo tmp;
		cout << "Nhap phan so thu: " << i + 1 << endl;
		tmp.nhapPS();
		_dsps.push_back(tmp);
	}
}

bool soSanhLon(PhanSo a, PhanSo b)
{
	return a.traGT() > b.traGT();
}

bool soSanhNho(PhanSo a, PhanSo b)
{
	return a.traGT() < b.traGT();
}

void DSPS::SapXep(bool(*soSanh)(PhanSo a, PhanSo b))
{
	for(int i=0;i<_size-1;i++)
		for (int j = 0; j < _size; j++)
		{
			if (soSanh(_dsps[i], _dsps[j]))
			{
				PhanSo tmp = _dsps[j];
				_dsps[j] = _dsps[i];
				_dsps[i] = tmp;
			}
		}
}

void DSPS::XuatDS()
{
	for (int i = 0; i < _size; i++)
	{
		cout << "Phan So thu " << i + 1 << ": ";
		_dsps[i].XuatPS();
	}
}

void main()
{
	//cau a
	PhanSo a, b;
	cout << "Moi nhap phan so a: ";
	a.nhapPS();
	cout << "\nMoi nhap phan so b: ";
	b.nhapPS();
	cout << "Tong 2 phan so: ";  (a + b).XuatPS();
	cout << "Hieu 2 phan so: "; (a - b).XuatPS();
	cout << "Tich 2 phan so: "; (a * b).XuatPS();
	cout << "Thuong 2 phan so: "; (a / b).XuatPS();

	DSPS c;
	cout << "Nhap danh sach phan so: ";
	c.NhapDSPS();
	c.SapXep(&soSanhLon);
	cout << "Danh sach duoc sap xep lon: \n";
	c.XuatDS();
	c.SapXep(&soSanhNho);
	cout << "Danh sach duoc sap xep nho: \n";
	c.XuatDS();
	_getch();
}
