#include "PhanSo.h"
#include<iostream>

using namespace std;

PhanSo::PhanSo()
{
	_tu = 0;
	_mau = 1;
}

PhanSo::PhanSo(int x, int y)
{
	_tu = x;
	_mau = y;
}

PhanSo::PhanSo(const PhanSo& p)
{
	_tu = p._tu;
	_mau = p._mau;
}

PhanSo::~PhanSo()
{

}

void PhanSo::nhapPS()
{
	cout << "Nhap tu va mau cua phan so: ";
	cin >> _tu >> _mau;
}

void PhanSo::XuatPS()
{
	cout << "( " << _tu << " / " << _mau << " )\n";
}

double PhanSo::traGT()
{
	return (_tu*1.0 / _mau);
}

PhanSo PhanSo::operator+(const PhanSo& p)
{
	PhanSo tmp;
	tmp._tu = _tu*p._mau + p._tu*_mau;
	tmp._mau = _mau * p._mau;
	return tmp;
}

PhanSo PhanSo::operator-(const PhanSo& p)
{
	PhanSo tmp;
	tmp._tu = _tu * p._mau - p._tu*_mau;
	tmp._mau = _mau * p._mau;
	return tmp;
}

PhanSo PhanSo::operator*(const PhanSo& p)
{
	PhanSo tmp;
	tmp._tu = _tu * p._tu;
	tmp._mau = _mau * p._mau;
	return tmp;
}

PhanSo PhanSo::operator/(const PhanSo& p)
{
	PhanSo tmp;
	tmp._tu = _tu * p._mau;
	tmp._mau = _mau + p._tu;
	return tmp;
}



